/**
 * InValueSet.java
 *
 * File generated from the XValidator4::InValueSet uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.exception.ValueSetNotFoundException;
import net.ihe.gazelle.xvalidation.core.report.Notification;
import net.ihe.gazelle.xvalidation.core.utils.Concept;
import net.ihe.gazelle.xvalidation.core.xpath.XpathUtils;

import org.w3c.dom.Node;

/**
 * Description of the class InValueSet.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "InValueSet", propOrder = { "locator", "lang", "valueSetId" })
@XmlRootElement(name = "InValueSet")
@Entity
@DiscriminatorValue("inValueSet")
public class InValueSet extends AbstractExpression implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@XmlElement(name = "Locator", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "locator_id")
	private Locator locator;

	@XmlAttribute(name = "lang")
	private String lang;

	@XmlAttribute(name = "valueSetId", required = true)
	@Column(name = "value_set_id")
	private String valueSetId;

	public InValueSet() {
		super();
		this.locator = new Locator();
	}

	public InValueSet(InValueSet exp){
		super();
		this.locator = new Locator(exp.getLocator());
		this.lang = exp.getLang();
		this.valueSetId = exp.getValueSetId();
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * Return locator.
	 * 
	 * @return locator
	 */
	public Locator getLocator() {
		return locator;
	}

	/**
	 * Set a value to attribute locator.
	 * 
	 * @param locator
	 *            .
	 */
	public void setLocator(Locator locator) {
		this.locator = locator;
	}

	/**
	 * Return lang.
	 * 
	 * @return lang
	 */
	public String getLang() {
		return lang;
	}

	/**
	 * Set a value to attribute lang.
	 * 
	 * @param lang
	 *            .
	 */
	public void setLang(String lang) {
		this.lang = lang;
	}

	/**
	 * Return valueSetId.
	 * 
	 * @return valueSetId
	 */
	public String getValueSetId() {
		return valueSetId;
	}

	/**
	 * Set a value to attribute valueSetId.
	 * 
	 * @param valueSetId
	 *            .
	 */
	public void setValueSetId(String valueSetId) {
		this.valueSetId = valueSetId;
	}

	@Override
	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "InValueSet", this);
		}
		return xmlNodePresentation;
	}

	@Override
	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	@Override
	public Notification evaluate(Map<String, Node> files, ValidatorConfiguration configuration, Level level){

		String value;
		List<Concept> concepts;
		boolean result = false;
		try{
			value = XpathUtils.getStringValue(files.get(locator.getAppliesOn()), locator,
					configuration.getNamespaceContext());
		} catch (GazelleXValidationException e){
			return abort("Error evaluating XPath : " + e.getMessage(), locator, "Error evaluating XPath " + locator.toString() + " : " + e.getMessage());
		}

		if (value == null || value.isEmpty()){
			return abort( "XPath did not select anything", locator, XpathUtils.getXPathReport(locator, value));
		}

		try {
			concepts = configuration.getValueSetProvider().getConceptsListFromValueSet(valueSetId, lang);
		} catch (GazelleXValidationException e){
			return abort( "Error retreiving value-set : "+e.getMessage(), e.getLocator(), "Error retreiving value-set : "+e.getMessage());
		}
		if (concepts == null || concepts.isEmpty()) {
			return abort( "Value set with id : " + getValueSetId() + " has not been found", locator, "Value set with id : " + getValueSetId() + " has not been found");
		} else {
			for (Concept concept : concepts) {
				if (concept.getCode().equals(value)) {
					result = true;
					break;
				}
			}
		}

		Notification resultNotification;
		if (!result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport("IN VALUE-SET (" + valueSetId + ") " + XpathUtils.getXPathReport(locator, value));
		return resultNotification;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append(this.locator.toString());
		builder.append(" exists in value set ");
		builder.append(this.valueSetId);
		if ((this.lang != null) && !this.lang.isEmpty()) {
			builder.append("&lang=");
			builder.append(this.lang);
		}
		return builder.toString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = (prime * result) + ((lang == null) ? 0 : lang.hashCode());
		result = (prime * result) + ((locator == null) ? 0 : locator.hashCode());
		result = (prime * result) + ((valueSetId == null) ? 0 : valueSetId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		InValueSet other = (InValueSet) obj;
		if (lang == null) {
			if (other.lang != null) {
				return false;
			}
		} else if (!lang.equals(other.lang)) {
			return false;
		}
		if (locator == null) {
			if (other.locator != null) {
				return false;
			}
		} else if (!locator.equals(other.locator)) {
			return false;
		}
		if (valueSetId == null) {
			if (other.valueSetId != null) {
				return false;
			}
		} else if (!valueSetId.equals(other.valueSetId)) {
			return false;
		}
		return true;
	}
	
	@Override
	public String getEditLink() {
		return "/xvalidation/expressions/inValueSet.xhtml";
	}

	@Override
	public void testCorrectness() throws AssertionFailedError {
		Assert.assertNotNull("[Expression #" + getFakeId() + "] Locator is null", locator);
		Assert.assertTrue("[Expression #" + getFakeId() + "] Locator is not correctly populated", locator.isValued());
		Assert.assertNotNull("[Expression #]" + getFakeId() + "] no value set ID provided", valueSetId);
		Assert.assertFalse("[Expression #]" + getFakeId() + "] no value set ID provided", valueSetId.isEmpty());
	}

	@Override
	public ArrayList<String> appliesTo() throws AssertionFailedError {
		ArrayList<String> keywords = new ArrayList<String>();
		testCorrectness();
		keywords.add(locator.getAppliesOn());
		return keywords;
	}

	@Override
	public AbstractExpression createCopy() {
		return new InValueSet(this);
	}
}